/*
 * Copyright ? 2005 Sun Microsystems Inc. All rights reserved. Use is subject to license terms.
 *  
 */

package com.sunlabs.archsim.fleet.ships.testing;

import com.sunlabs.archsim.base.hierarchy.CompositeEntity;
import com.sunlabs.archsim.base.simulation.Delay;
import com.sunlabs.archsim.fleet.common.Data;
import com.sunlabs.archsim.fleet.common.OutputFunction;
import com.sunlabs.archsim.gasp.Action;
import com.sunlabs.archsim.gasp.terminals.InputTerminal;
import com.sunlabs.archsim.gasp.terminals.OutputTerminal;


class AckAction extends Action {

        /* come constants */
    
        private String IN= "AckAction.In";
        private String ACK_IN= "AckAction.ackIn";
        
	/* terminals */
        
	InputTerminal in;
	OutputTerminal ackIn;
		
	public AckAction(String name, CompositeEntity parent){
		super(name);
                
                // update terminal names
                IN= name + ".In";
                ACK_IN= name + ".ackIn";
                
                // create terminals
                in= new InputTerminal(IN, parent);
                ackIn= new OutputTerminal(ACK_IN, parent);
                
                // attach terminal to this action
                this.attach(in);
                this.attach(ackIn);
                
		// associate done with the external done output
		outputFunctions.put(ACK_IN, new AckFunction());
	}
	     
        public InputTerminal getIn() {
                return in;
        }
        
        public OutputTerminal getAckIn() {
                return ackIn;
        }
        
        private class AckFunction extends OutputFunction {

                public AckFunction() {
                        this("AckFunction");
                }

                public AckFunction(String name) {
                        super(name);
                        
                        // set function delay
                        functionDelay= TestingDefaults.DEFAULT_FUNCTION_DELAY;
                }

                public Data value() {
                        return new Data();
                } // value
	
        } // AckFunction
        
        
} // class OutputAction
