/**
 * Copyright 2005 Sun Microsystems Inc. All rights reserved. Use is subject to license terms.
 */
package com.sunlabs.archsim.testDriver;

import junit.framework.TestSuite;
import junit.textui.TestRunner;

import com.sunlabs.archsim.fleet.components.trunk.TrunkTest;
import com.sunlabs.archsim.fleet.fleets.fibonacci.FibonacciTest;
import com.sunlabs.archsim.fleet.ships.accumulator.TestAccumulator;
import com.sunlabs.archsim.fleet.ships.adder.TestAdder;
import com.sunlabs.archsim.fleet.ships.adder_oob.TestAdder_oob;
import com.sunlabs.archsim.fleet.ships.bitbucket.BitBucketTest;
import com.sunlabs.archsim.fleet.ships.constant.ConstantTest;
import com.sunlabs.archsim.fleet.ships.fifo.FifoTest;
import com.sunlabs.archsim.fleet.ships.memory.SimpleMemoryTest;
import com.sunlabs.archsim.fleet.ships.selector.TestSelector;
import com.sunlabs.archsim.fleet.ships.stride.StrideJUTest;
import com.sunlabs.archsim.fleet.ships.tokenFifo.TokenFifoTest;
import com.sunlabs.archsim.fleet.ships.tokenaccumulator.TestTokenAccumulator;
import com.sunlabs.archsim.fleet.ships.tokenadder.TestTokenAdder;

/**
 * This program invokes tests for Fleet related archsim packages.
 * @author ib27688
 */
public class JUFleetTestDriver {

	/**
	 * @param args
	 */
	public static void main(String[] args) {
        
		// package all tests into a suite
        TestSuite suite= new TestSuite();
		suite.addTestSuite(FifoTest.class);
		suite.addTestSuite(StrideJUTest.class);
		suite.addTestSuite(BitBucketTest.class);
		suite.addTestSuite(TrunkTest.class);
		suite.addTestSuite(TestAdder.class);
		suite.addTestSuite(TestTokenAdder.class);
		suite.addTestSuite(TestAdder_oob.class);
		suite.addTestSuite(TestSelector.class);
		suite.addTestSuite(SimpleMemoryTest.class);
		suite.addTestSuite(FibonacciTest.class);
		suite.addTestSuite(ConstantTest.class);
		suite.addTestSuite(TestTokenAccumulator.class);
		suite.addTestSuite(TestAccumulator.class);
		suite.addTestSuite(TokenFifoTest.class);
		
		// run the suite
		TestRunner.run(suite);
        
	}

}
