/*
 * Copyright  2005 Sun Microsystems Inc. All rights reserved. Use is subject to license terms.
 *  
 */

/*
 * Created on Feb 9, 2005
 *
 */
package com.sunlabs.archsim.tests.arbiter;

import java.util.Iterator;

import com.sunlabs.archsim.base.simulation.Delay;
import com.sunlabs.archsim.gasp.Action;
import com.sunlabs.archsim.gasp.Function;
import com.sunlabs.archsim.gasp.Terminal;

/**
 * @author ib27688
 *
 * The sink for data generated in the arbiter test.
 */
public class ArbiterTestSink extends Action {
	
	public ArbiterTestSink(String name) {
		super(name);
		outputFunctions.put(ArbiterTestGlobal.ACK_DATA_IN_TERMINAL_NAME,
							new ActionFired());
	} // FifoAction
	
	/** Vacuous function used to acknowldge that the action has fired */ 
	private class ActionFired extends Function {
		
		public ActionFired() {
			super("Vacous");
			functionDelay= new Delay(0); // was 10
		}
	
		public Object value() {
			Iterator ti= terminals.iterator();
			Terminal t= null;
			boolean done= false;
			while (!done && ti.hasNext()) {
				t= (Terminal)(ti.next());
				if (t.getBaseName() == "dataIn") {
					done= true;
				}
			}
			if (t != null && ArbiterTestGlobal.sinkDisplayReceived ) {
				director.journal("Sink received " + t.getData());
			}
			return null;
		} // value
	} // AcknowledgeData

	
} // ArbiterTestSink
